'''
Created on 29.06.2012

@author: dervish
'''

from Products.Five.browser import BrowserView
from operator import attrgetter
from itertools import imap
from Products.CMFCore.utils import getToolByName
from Products.CMFPlone.PloneBatch import Batch

from operator import itemgetter, attrgetter
from itertools import imap
from collections import namedtuple
import csv


class TableView(BrowserView):
    """Competition statistics table"""

    def __init__(self, context, request):
        self.context = context
        self.request = request

    @property
    def fields(self):
        source = self.context.import_file
        fields = ['rank'] + csv.DictReader(source.data.splitlines()).fieldnames
        return fields
    
    def results(self, batch=True, b_start=0, b_size=30, sort_on=None, brains=False):
        """Get results"""
        # get the csv data
        source = self.context.import_file

        data = {}
        reader = csv.DictReader(source.data.splitlines())
        for i, row in enumerate(reader):
            row['rank'] = i+1
            data[row['name']] = row

        catalog = getToolByName(self.context, 'portal_catalog')
        brains = catalog(portal_type='plone.tournament.Team',
                         Title = ' or '.join('"%s"' % key for key in data.keys()))

        Item = namedtuple('Item', ['brain', 'rank'] + reader.fieldnames)
        # extend brains with data using monkeypatching
        items = []
        for b in brains:
            data[b.Title]['brain'] = b
            items.append(Item(**data[b.Title]))
        return Batch(sorted(items, key=attrgetter('rank')), 30)
       
